#! /bin/sh
# wdimex.sh -- make the message file for hysep
#
# History:  96/03/15 kmflynn
#           98/01/21 kmflynn
#
# Usage: wdimex.sh [ file_name ] [| tee wdimex.out]
#
# Where: file_name = the name of the message file or test wdm file to build
#                    hyspms - to generate the hysep message file (default)
#                    french - generate french wdm file

# pathname and library versions
  WrdA=/usr/opt/wrdapp
  Libr=$WrdA/lib3.2
  LibI=$WrdA/iowdm2.3

#*******************************************************************
#***** You should not need to modify anything below this line. *****
#*******************************************************************

Name=${1-'hyspms'}
     if [ ! $Name ] ; then Name=hyspms ; fi

# hysep message file
  Seqs='hyspms'
  SeqL='waide/agplot'
  SeqI='iowdmc'

  echo
  echo ' Building wdm files'
  echo '           Library:' $Libr
  echo '          wdm name:' $Name.wdm

# remove any old files
  if [ -f $Name.wdm ] ; then rm $Name.wdm ; fi
  if [ -f error.fil ] ; then rm error.fil ; fi
  if [ -f $Name.in ] ; then rm $Name.in ; fi

  if [ $Name = 'hyspms' ] ; then
#    build the message file
     echo '       sequentials:' $Seqs
     echo '                   ' $SeqL
     echo '                   ' $SeqI
     echo

#    build input file
     echo $Name.wdm > $Name.in
     for Seq in $Seqs ; do
        echo I >> $Name.in
        echo $Seq.seq >> $Name.in
     done
     for Seq in $SeqL ; do
        echo I >> $Name.in
        echo $Libr/msg/$Seq.seq >> $Name.in
     done
     for Seq in $SeqI ; do
        echo I >> $Name.in
        echo $LibI/msg/$Seq.seq >> $Name.in
     done
     echo R >> $Name.in

#    get message file shell
     cp $Libr/lib_data/message.wdm $Name.wdm

#    build message file
     $Libr/bin/wdimex < $Name.in

#    remove old message file and move new one into bin
     if [ -f ../bin_data/$Name.wdm ] ; then rm ../bin_data/$Name.wdm ; fi
     mv $Name.wdm ../bin_data

  else
#    build the wdm for french
     echo '        sequential:' ../data/$Name.exp
     echo

#    build input file
     echo $Name.wdm > $Name.in
     echo C >> $Name.in
     echo N >> $Name.in
     echo $Libr/lib_data/message.wdm >> $Name.in
     echo I >> $Name.in
     echo ../data/$Name.exp >> $Name.in
     echo R >> $Name.in

#    build the test wdm file
     $Libr/bin/wdimex < $Name.in

#    remove old wdm file and move new one into data
     if [ -f ../data/$Name.wdm ] ; then rm ../data/$Name.wdm ; fi
     mv $Name.wdm ../data/$Name.wdm

  fi

# end of shell
