C
C
C
      PROGRAM   HYSEP
C
C     + + + PURPOSE + + +
C     *********************************
C     *         HYSEP.F77             *
C     * HYDROGRAPH SEPARATION PROGRAM *
C     *        R. A. SLOTO            *
C     *        REV 10/5/88            *
C     * OSW REV 4/21/89 AMLUMB        *
C     * OSW REV 4/08/91 AMLUMB KMFLYNN*
C     *HASS REV 11/6/91 AMLUMB MYGOZE *
C     *********************************
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmesfl.inc'
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER*8  LOGNAM
      CHARACTER*10 APNAME
      CHARACTER*64 FNAME, VERSN
C
C     + + + EXTERNALS + + +
      EXTERNAL   ANINIZ, ANCLOS, ZANSET
      EXTERNAL   HYSPDR
C
C     + + + END SPECIFICATIONS + + +
C
C     get name of application, log file, and message file
      INCLUDE 'fhysep.inc'
C     open message file and initialize aide environment
      CALL ANINIZ (MESSFL, FNAME, LOGNAM)
C
C     set application name
      CALL ZANSET (APNAME)
C
C     call hysep driver
      CALL HYSPDR (MESSFL)
C
C     close message file
      CALL ANCLOS (MESSFL)
C
      STOP
      END
C
C
C
      SUBROUTINE   HYSPDR 
     I                   (MESSFL) 
C
C     + + + PURPOSE + + +
C     Drives program.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C
C     + + + PARAMETERS + + +
      INCLUDE 'pdsnmx.inc'
      INCLUDE 'pbasln.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I0, I1, L3, L6, L10, L12, SGRP, SCLU, WDMSFL, MOPT, 
     $             LINE, DSNCNT, DSNBUF(DSNBMX), DMAX, METH, MONFLG, 
     $             PRTFLG, FRQPRT, DURPRT, SEAPRT, ROWAT, BFWAT, ROWDM,
     $             BFWDM, UNITFG, ENGOPT, PLTDEV(2,3), FRQOPT(3), 
     $             DUROPT(3), SEAOPT, HYDDEV(2), MODOPT, OTCNTR(2:4,4), 
     $             BASLEN, FE, WSID, ICLOS, IWAIT, FLATFL
      CHARACTER*1  BASNAM(BSLNMX)
      CHARACTER*10 TMPNAM
      CHARACTER*16 METHOD
C
C     + + + FUNCTIONS + + +
      INTEGER    LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   GPOPEN, GPCLOS, PDNPLT
      EXTERNAL   QRESP, PRNTXT
      EXTERNAL   ZIPI, CVARAR, LENSTR
      EXTERNAL   WDMINP, WATINP, BSOTPT, BSGRPH, BSMTHD, BSEXEC, BSSTAT
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 0
      I1 = 1
      L3 = 3
      L6 = 6
      L10 = 10
      L12 = 12
      SCLU = 101
C
C     open GKS and err. file, add err. file unit no. to CPLOT common blk
      CALL GPOPEN(FE)
C     init. graphical output file counters to 1 (for first plot)
      CALL ZIPI (L12, I1, OTCNTR)
C
C     set defaults
      METH = 1
      METHOD = 'Fixed interval  '
      WDMSFL = 0
      FLATFL = 0
      DMAX = DSNBMX
      DSNCNT = 0
C     zero out data-set buffer
      CALL ZIPI(DMAX, I0, DSNBUF)
C     set print file and data output defaults
      MONFLG = 10
      PRTFLG = 0
      FRQPRT = 0
      DURPRT = 0
      SEAPRT = 0
      ROWAT = 0
      BFWAT = 0
      ROWDM = 0
      BFWDM = 0
      UNITFG = 1
      ENGOPT = 1
C     set graphics output devices
      CALL ZIPI (L6, I0, PLTDEV)
      HYDDEV(1) = 1
      HYDDEV(2) = 0
C     set graphics output defaults
      CALL ZIPI (L3, I1, FRQOPT)
      CALL ZIPI (L3, I1, DUROPT)
      SEAOPT = 1
      MODOPT = 0
C
C     set length of basename to be used in all output filenames
      BASLEN = BSLNMX
C     set default basename
      TMPNAM = 'hysep'
      CALL CVARAR (LENSTR(L10, TMPNAM), TMPNAM, BASLEN, BASNAM)
C
C     put initial status in status window
      LINE = 0
      CALL BSSTAT (LINE, WDMSFL, BASLEN, BASNAM, DSNCNT, METHOD)
 100  CONTINUE
C       opening menu select (1-WATSTORE input, 2-WDM input, 3-Output, 
C                            4-Plots, 5-Method, 6-Execute, 7-Query, 
C                            8-Return)
        SGRP = 1
        MOPT = 1
        CALL QRESP (MESSFL, SCLU, SGRP, MOPT)
        IF (MOPT .EQ. 1) THEN
C         specify WATSTORE input file 
          CALL WATINP (MESSFL, SCLU, DMAX,
     M                 WDMSFL, FLATFL, DSNBUF, DSNCNT)
        ELSE IF (MOPT .EQ. 2) THEN
C         specify WDM input file and data sets
          CALL WDMINP (MESSFL, SCLU, DMAX,
     M                 WDMSFL, FLATFL, DSNBUF, DSNCNT)
        ELSE IF (MOPT .EQ. 3) THEN
C         define output options
          CALL BSOTPT (MESSFL, SCLU, WDMSFL, FLATFL,
     M                 MONFLG, PRTFLG, FRQPRT, DURPRT, SEAPRT, ROWAT,
     M                 BFWAT, ROWDM, BFWDM, UNITFG, ENGOPT)
        ELSE IF (MOPT .EQ. 4) THEN
C         choose graphic options
          CALL BSGRPH (MESSFL, SCLU,
     M                 PLTDEV, HYDDEV, FRQOPT, DUROPT, SEAOPT, MODOPT)
        ELSE IF (MOPT .EQ. 5) THEN
C         select base flow separation method
          CALL BSMTHD (MESSFL, SCLU, METH)
        ELSE IF (MOPT .EQ. 6) THEN
C         compute base flow
          IF (WDMSFL .EQ. 0) THEN
C           can't compute base flow, no source input file
            SGRP = 68
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE IF (FLATFL.EQ.0 .AND. DSNCNT.EQ.0) THEN
C           WDM file opened for input but no data sets selected
            SGRP = 69
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           at least minimum options selected
            IF (FLATFL .NE. 0) THEN
C             turn off WDM output options (may or may not be selected)
              ROWDM = 0
              BFWDM = 0
            END IF
            CALL BSEXEC (MESSFL, SCLU, WDMSFL, DSNCNT, DSNBUF, METH, 
     I                   MONFLG, PRTFLG, FRQPRT, DURPRT, SEAPRT, ROWAT, 
     I                   BFWAT, ROWDM, BFWDM, UNITFG, ENGOPT, PLTDEV, 
     I                   HYDDEV, FRQOPT, DUROPT, SEAOPT, MODOPT, 
     I                   BASLEN, 
     M                   BASNAM, OTCNTR)
C           reset plot modification flag to NO
            MODOPT = 0
          END IF
        ELSE IF (MOPT .EQ. 7) THEN
C         display info. on technical assistance
          SGRP = 101
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        END IF
      IF (MOPT .NE. 8) GO TO 100
C
C     close graphics workstation used for plots displayed to screen
      WSID = 2
      ICLOS = 1
      IWAIT = 0
      CALL PDNPLT (WSID, ICLOS, IWAIT)
C
C     close GKS
      CALL GPCLOS (FE)
C
      IF (FLATFL .NE. 0) THEN
C       close and delete temp. WDM file used to process WATSTORE input
        CLOSE (UNIT=WDMSFL, STATUS='DELETE')
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDMINP 
     I                   (MESSFL, SCLU, DMAX,
     M                    WDMSFL, FLATFL, DSNBUF, DSNCNT)
C
C     + + + PURPOSE + + +
C     Prompts user for input and opens specified file.  A WDM file or a
C     WATSTORE file of daily values in card-image format may be used as
C     input.
C
C     + + + DUMMY ARUGMENTS + + +
      INTEGER   MESSFL, SCLU, DMAX, WDMSFL, FLATFL, DSNBUF(DMAX), DSNCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - screen cluster number on message file
C     DMAX   - maximum number of data sets allowed
C     WDMSFL - Fortran unit number of wdm file
C     FLATFL - Fortran unit number of WATSTORE input (flat) file
C     DSNBUF - buffer of selected data sets
C     DSNCNT - number of data sets in the data set buffer
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, I0, I1, SGRP, OPT, LINE, DUMLEN, BLDOPT, TMPWDM, 
     $             UNITNO, RETCOD, PREVWD
      CHARACTER*1  DUM1(1), BLNKLN(78)
      CHARACTER*8  PTHNAM
      CHARACTER*16 CDUM
      CHARACTER*64 WDNAME
C
C     + + + LOCAL DEFINITIONS + + +
C     TMPWDM - unit number of temporary WDM file used in processing
C              WATSTORE input--passed in as WDMSFL if a WATSTORE file
C              has been previously opened 
C     UNITNO - unit number of input file whose name should be displayed
C              in status window.  If WATSTORE file previously opened,
C              and no WDM file opened in this routine, the unit number
C              of the WATSTORE flat file is stored in UNITNO, not the
C              unit number of the temporary WDM file used in processing
C              the WATSTORE input.
C
C     + + + EXTERNALS + + +
      EXTERNAL     WDFLCL
      EXTERNAL     QRESP, QFCLOS, PRWFLE, PRWMSE, PRNTXT, ZSTADQ
      EXTERNAL     ZIPI
      EXTERNAL     BSSTAT
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 0 
      I1 = 1 
      DUMLEN = 1
      DUM1(1) = ' '
      CDUM = 'from wdminp'
      DO 10 I = 1, 78
        BLNKLN(I) = ' '
 10   CONTINUE
      UNITNO = 0
      TMPWDM = 0
      PREVWD = 0
C     assign name for temporary WDM file used for WATSTORE input
      WDNAME = 'hy99999.tmp'
C
C     set pathname for windows in PRWFLE, PRWMSE
      PTHNAM = 'W'
C
 100  CONTINUE
C       if WDM file currently open, save unit number
        IF (FLATFL .EQ. 0) PREVWD = WDMSFL
C       select an input option (1-file, 2-data sets, 3-return)
        SGRP = 21
        CALL QRESP (MESSFL, SCLU, SGRP, OPT)
        IF (OPT.NE.3 .AND. FLATFL.NE.0) THEN
C         WATSTORE file already open, save unit no. and reinit. WDMSFL
          TMPWDM = WDMSFL
          WDMSFL = 0
        END IF
C
        IF (OPT .EQ. 1) THEN
C         open WDM file
C         blank out lines in status window for input file name and sta.s
          LINE = 1
          CALL ZSTADQ (LINE, BLNKLN, I0)
          LINE = 2
          CALL ZSTADQ (LINE, BLNKLN, I0)
C         don't allow option to build a WDM file
          BLDOPT = 0
          CALL PRWFLE (MESSFL, BLDOPT, PTHNAM,
     M                 WDMSFL)
C
          IF (WDMSFL.EQ.0 .AND. FLATFL.NE.0) THEN
C           WDM file not opened, reset WDMSFL to unit number of 
C           temporary WDM file used in processing WATSTORE input
            WDMSFL = TMPWDM
          ELSE IF (WDMSFL.EQ.0 .OR. 
     $            (PREVWD.NE.0 .AND. WDMSFL.NE.PREVWD)) THEN
C           WDM file not opened and no WATSTORE file open -OR-
C           diff. WDM file opened from one previously open
            IF (DSNCNT .NE. 0) THEN
C             data-set buffer not empty, clear it out
              CALL ZIPI (DSNCNT, I0, DSNBUF)
              DSNCNT = 0
            END IF
          ELSE IF (FLATFL .NE. 0) THEN
C           WDM file successfully opened, close WATSTORE file
            CALL QFCLOS (FLATFL, I0)
            FLATFL = 0
C           close temporary WDM used in processing WATSTORE file
            CALL WDFLCL (TMPWDM, RETCOD)
C           reopen temporary WDM file so can close and delete
            OPEN (UNIT=TMPWDM, FILE=WDNAME, STATUS='OLD')
            CALL QFCLOS (TMPWDM, I1)
            TMPWDM = 0
            IF (DSNCNT .NE. 0) THEN
C             data-set buffer not empty, clear it out 
              CALL ZIPI (DSNCNT, I0, DSNBUF)
              DSNCNT = 0
            END IF
          END IF
C
          IF (FLATFL .NE. 0) THEN
C           WATSTORE input--no WDM file successfully opened
            UNITNO = FLATFL
          ELSE
            UNITNO = WDMSFL
          END IF
C         show name in status window, or print msg. that no file spec'd.
          LINE = 1
          CALL BSSTAT (LINE, UNITNO, DUMLEN, DUM1, DSNCNT, CDUM)
C         show number of stations to be processed in status window
          LINE = 2
          CALL BSSTAT (LINE, UNITNO, DUMLEN, DUM1, DSNCNT, CDUM)
        ELSE IF (OPT .EQ. 2) THEN
C         select data set(s)
          IF (WDMSFL .NE. 0) THEN
C           wdm is open, get data sets
C           blank out line in status window for no. of stations 2B processed
            LINE = 2
            CALL ZSTADQ (LINE, BLNKLN, I0)
            CALL PRWMSE (MESSFL, WDMSFL, DMAX, PTHNAM,
     M                   DSNBUF, DSNCNT)
C           update number of stations in status window
            CALL BSSTAT (LINE, UNITNO, DUMLEN, DUM1, DSNCNT, CDUM)
          ELSE
C           can't add data sets, no wdm file open
            SGRP = 22
            CALL PRNTXT (MESSFL, SCLU, SGRP)
C           if WATSTORE file open, reset WDMSFL to unit no. of temp. WDM
            IF (FLATFL .NE. 0) WDMSFL = TMPWDM
          END IF
        END IF
      IF (OPT .NE. 3) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   WATINP
     I                   (MESSFL, SCLU, DMAX,
     M                    WDMSFL, FLATFL, DSNBUF, DSNCNT)
C
C     + + + PURPOSE + + +
C     Opens WATSTORE input file specified by user, prompts for station
C     details.  Data is read into a temporary WDM file for internal
C     processing.  Fortran unit number of temporary WDM file and data-
C     set buffer and count are returned as in WDMINP.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      MESSFL, SCLU, DMAX, WDMSFL, FLATFL, DSNBUF(DMAX), 
     $             DSNCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - screen cluster number on message file
C     DMAX   - maximum number of data sets allowed
C     WDMSFL - Fortran unit number of wdm file
C     FLATFL - Fortran unit number of WATSTORE input (flat) file
C     DSNBUF - buffer of selected data sets
C     DSNCNT - number of data sets in the data set buffer
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, I0, I1, I2, SGRP, RETCOD, RONWFG, FE, 
     $             SUMOUT, DSSTAT, CNFRM, DSINCR, DSN, PTHLEN, AVER, 
     $             SPACE(5), TIME(7), DUMLEN, LINE, UNITNO, WATFIL, 
     $             MAXLIN, SCINIT, IWRT, LINCNT
      CHARACTER*1  DUM1(1), BLNKLN(78)
      CHARACTER*8  PTHNAM(1)
      CHARACTER*16 CDUM
      CHARACTER*64 WDNAME
      LOGICAL      FLEXST
C
C     + + + LOCAL DEFINITIONS + + +
C     UNITNO - at the beginning of this routine, UNITNO is set to
C              any previously opened input file; by end of routine 
C              UNITNO is reset to the unit number of WATSTORE input
C              file opened in this routine (if any)
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDBOPN
      EXTERNAL  QFOPEN, QFCLOS, PRNTXT, PRNTXI, ZSTADQ, PMXCNW, GETFUN
      EXTERNAL  ZIPI
      EXTERNAL  INITAT
      EXTERNAL  HYINWD, BSSTAT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SPACE
     $     /35,70,150,1,1/
      DATA  TIME
     $     /4,6,1,1,1,1900,1/
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 0
      I1 = 1
      I2 = 2
      DUMLEN = 1
      DUM1(1) = ' '
      CDUM = 'from watinp'
      DO 10 I = 1, 78
        BLNKLN(I) = ' '
 10   CONTINUE
      UNITNO = 0
C     assign name for temporary WDM file
      WDNAME = 'hy99999.tmp'
C
C     blank out lines in status window for input file name and stations
      LINE = 1
      CALL ZSTADQ (LINE, BLNKLN, I0)
      LINE = 2
      CALL ZSTADQ (LINE, BLNKLN, I0)
C
      IF (WDMSFL .NE. 0) THEN
C       input file already open, save unit number 
        IF (FLATFL .NE. 0) THEN
C         WATSTORE file has been opened, save unit number of flat file
          UNITNO = FLATFL
        ELSE
C         WDM file has been opened
          UNITNO = WDMSFL
        END IF
      END IF
C
C     prompt user for WATSTORE filename
      SGRP = 11
      CALL QFOPEN (MESSFL, SCLU, SGRP,
     O             WATFIL, RETCOD)
C
      IF (RETCOD .EQ. 0) THEN
        IF (UNITNO .NE. 0) THEN
C         an input file is already open
C         close WDM file (regular or temporary)
          CALL WDFLCL (WDMSFL, RETCOD)
          IF (FLATFL .EQ. 0) THEN
C           free up Fortran unit number of WDM file just closed
            CALL GETFUN (I2, WDMSFL)
          ELSE
C           close WATSTORE file
            CALL QFCLOS (FLATFL, I0)
            FLATFL = 0
C           reopen temporary WDM file so can close and delete 
            OPEN (UNIT=WDMSFL, FILE=WDNAME, STATUS='OLD')
            CALL QFCLOS (WDMSFL, I1)
          END IF
          WDMSFL = 0
          UNITNO = 0
          IF (DSNCNT .NE. 0) THEN
C           data-set buffer not empty, clear it out
            CALL ZIPI (DSNCNT, I0, DSNBUF)
            DSNCNT = 0
          END IF
        END IF
C
        INQUIRE (FILE=WDNAME, EXIST=FLEXST)
        IF (FLEXST) THEN
C         temp file exists from previous run--open, then close and delete
C         get Fortran unit number for temporary WDM file
          CALL GETFUN (I1,
     M                 WDMSFL)
          OPEN (UNIT=WDMSFL, FILE=WDNAME, STATUS='OLD', IOSTAT=RETCOD)
          IF (RETCOD .EQ. 0) THEN
C           close and delete old temporary file
            CALL QFCLOS (WDMSFL, I1)
          ELSE
C           couldn't open old temporary file, display error message
            SGRP = 13
            CALL PRNTXI (MESSFL, SCLU, SGRP, RETCOD)
          END IF
          WDMSFL = 0
        END IF
C
        IF (RETCOD .EQ. 0) THEN
C         open (new) temporary WDM file
C         get Fortran unit number for temporary WDM file
          CALL GETFUN (I1,
     M                 WDMSFL)
          RONWFG = 2
          CALL WDBOPN (WDMSFL, WDNAME, RONWFG,
     O                 RETCOD)
          IF (RETCOD .EQ. 0) THEN
C           temporary WDM file opened successfully, display prog. report
            MAXLIN = 10
            SCINIT = 1
            IWRT = 1
            SGRP = 14
            CALL PMXCNW (MESSFL, SCLU, SGRP, MAXLIN, SCINIT, IWRT,
     O                   LINCNT)
C           initialize arrays used for attribute identification
            AVER = 1
            CALL INITAT (AVER, SPACE, TIME)
C           read in data
            FE = 99
            SUMOUT = 0
            DSSTAT = 1
            CNFRM = 1
            DSINCR = 1
            PTHLEN = 1
            PTHNAM(1) = ' '
            DSN = 1
            CALL HYINWD (MESSFL, WDMSFL, FE, WATFIL, SUMOUT,
     I                   DSSTAT, CNFRM, DSINCR, PTHLEN, PTHNAM,
     M                   DSN)
C           value of DSN ==> number assigned to last station read
            IF (DSN .EQ. 0) THEN
C             couldn't read WATSTORE file
              SGRP = 15
              CALL PRNTXT (MESSFL, SCLU, SGRP)
C             close WATSTORE file
              CALL QFCLOS (WATFIL, I0)
C             close temporary WDM file
              CALL WDFLCL (WDMSFL, RETCOD)
C             reopen temporary WDM file so can close and delete
              OPEN (UNIT=WDMSFL, FILE=WDNAME, STATUS='OLD')
              CALL QFCLOS (WDMSFL, I1)
              WDMSFL = 0
            ELSE
              FLATFL = WATFIL
              DSNCNT = DSN
C             fill data-set buffer
              DO 20 I = DSNCNT, 1, -1
                DSNBUF(I) = I
 20           CONTINUE
              UNITNO = FLATFL
            END IF
          ELSE
C           couldn't open temporary WDM file
            SGRP = 12
            CALL PRNTXI (MESSFL, SCLU, SGRP, -RETCOD)
            WDMSFL = 0
C           close WATSTORE file
            CALL QFCLOS (WATFIL, I0)
          END IF
C       end if (retcod .eq. 0)
        END IF
C     end if (retcod .eq. 0)
      END IF
C
C     show input file name (or no name if none opened) in status window
      LINE = 1
      CALL BSSTAT (LINE, UNITNO, DUMLEN, DUM1, DSNCNT, CDUM)
C     update number of stations to be processed in status window
      LINE = 2
      CALL BSSTAT (LINE, UNITNO, DUMLEN, DUM1, DSNCNT, CDUM)
C
      RETURN
      END
C
C
C
      SUBROUTINE   BSOTPT
     I                   (MESSFL, SCLU, WDMSFL, FLATFL,
     M                    MONFLG, PRTFLG, FRQPRT, DURPRT, SEAPRT, ROWAT,
     M                    BFWAT, ROWDM, BFWDM, UNITFG, ENGOPT)
C
C     + + + PURPOSE + + +
C     Displays print file/data output options to user for selection.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      MESSFL, SCLU, WDMSFL, FLATFL, MONFLG, PRTFLG, FRQPRT,
     $             DURPRT, SEAPRT, ROWAT, BFWAT, ROWDM, BFWDM, UNITFG, 
     $             ENGOPT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of the message file
C     SCLU   - screen cluster number on message file
C     WDMSFL - Fortran unit number of WDM input file
C     FLATFL - Fortran unit number of WATSTORE input (flat) file
C     for the following flags, unless otherwise specified, 0=NO, 1=YES
C     MONFLG - First month for annual summaries
C              1=Jan, 2=Feb,...,12=Dec 
C     PRTFLG - monthly summary printout flag
C     FRQPRT - frequency distribution table flag
C     DURPRT - flow duration table flag 
C     SEAPRT - seasonal distribution table flag
C     ROWAT  - ASCII surface runoff output flag
C     BFWAT  - ASCII base flow output flag
C     ROWDM  - WDM surface runoff output flag
C     BFWDM  - WDM base flow output flag
C     UNITFG - print file units
C              1 - english
C              2 - metric
C     ENGOPT - units for base flow in predefined columns of print file
C              1 - Mgal/d/mi2
C              2 - Mgal/d
C              3 - ft3/s/mi2
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I0, I1, SGRP, CNUM, CVAL(10), IRET, ICMD, OPCNT,
     $          OPLEN, MNSEL(1), MXSEL(1), OPVAL(1)
      LOGICAL   WDMIN
C
C     + + + EXTERNALS + + +
      EXTERNAL   Q1INIT, QSETCO, QGETCO, QSETOP, QGETOP, Q1EDIT, ZSTCMA
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 1
      I1 = 1
C
C     allow 'Previous' command
      ICMD = 4
      CALL ZSTCMA (ICMD, I1)
C
      WDMIN = .FALSE.
C     set flag if WDM input file opened
      IF (WDMSFL.NE.0 .AND. FLATFL.EQ.0) WDMIN = .TRUE.
C
 10   CONTINUE
C       display output options screen
        IF (WDMIN) THEN
C         display screen with WDM output options
          SGRP = 31
          CNUM = 10
        ELSE
C         display screen without WDM output options
          SGRP = 32
          CNUM = 8
        END IF
        CALL Q1INIT (MESSFL, SCLU, SGRP)
C       supply defaults to screen
        CVAL(1) = MONFLG
        CVAL(2) = PRTFLG + 1
        CVAL(3) = FRQPRT + 1
        CVAL(4) = DURPRT + 1
        CVAL(5) = SEAPRT + 1
        CVAL(6) = UNITFG
        CVAL(7) = ROWAT + 1
        CVAL(8) = BFWAT + 1
        IF (WDMIN) THEN 
          CVAL(9) = ROWDM + 1
          CVAL(10) = BFWDM + 1
        ELSE
          CVAL(9) = 0
          CVAL(10) = 0
        END IF
        CALL QSETCO (CNUM, CVAL)
        OPCNT = 1
        OPLEN = 1
        MXSEL(1) = 1
        MNSEL(1) = 1
        OPVAL(1) = ENGOPT
        CALL QSETOP (OPCNT, OPLEN, MXSEL, MNSEL, OPVAL)
C       allow user to edit values on screen
        CALL Q1EDIT (IRET)
C
C     if user chose 'Oops' redraw screen
      IF (IRET .EQ. -1) GOTO 10
C
      IF (IRET .EQ. 1) THEN
C       user wants to continue
C       get character strings from screen
        CALL QGETCO (CNUM, CVAL)
        MONFLG = CVAL(1)
        PRTFLG = CVAL(2) - 1
        FRQPRT = CVAL(3) - 1
        DURPRT = CVAL(4) - 1
        SEAPRT = CVAL(5) - 1
        UNITFG = CVAL(6)
        ROWAT = CVAL(7) - 1
        BFWAT = CVAL(8) - 1
        IF (WDMIN) THEN 
          ROWDM = CVAL(9) - 1
          BFWDM = CVAL(10) - 1
        ELSE
          ROWDM = 0
          BFWDM = 0
        END IF
C       get value for option fields
        CALL QGETOP (OPLEN,
     O               OPVAL)
        ENGOPT = OPVAL(1)
      END IF
C
C     turn off 'Previous'
      CALL ZSTCMA (ICMD, I0)
C
      RETURN
      END
C
C
C
      SUBROUTINE   BSGRPH
     I                   (MESSFL, SCLU, 
     M                    PLTDEV, HYDDEV, FRQOPT, DUROPT, SEAOPT, 
     M                    MODOPT)
C
C     + + + PURPOSE + + +
C     Displays and allows user to select graphical display options.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, SCLU, PLTDEV(2,3), HYDDEV(2), FRQOPT(3), 
     $          DUROPT(3), SEAOPT, MODOPT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - screen cluster number on message file
C     the following two arguments can contain these values:
C              1 - screen
C              2 - laser or dot matrix printer
C              3 - pen plotter
C              4 - meta file
C     PLTDEV - array of output devices; 2 output devices possible per plot
C              PLTDEV(1:2,1) - for frequency distribution plot 
C              PLTDEV(1:2,2) - for flow duration plot
C              PLTDEV(1:2,3) - for seasonal bar chart
C     HYDDEV - array of output devices for hydrograph
C     the flags in the following arrays can have 2 values:  0-NO, 1-YES
C     FRQOPT - array of flags of frequency distribution plot options
C              FRQOPT(1) - total flow 
C              FRQOPT(2) - surface runoff
C              FRQOPT(3) - base flow
C     DUROPT - array of flags of flow duration plot options
C              DUROPT(1) - total flow 
C              DUROPT(2) - surface runoff
C              DUROPT(3) - base flow
C     SEAOPT - seasonal bar chart option
C              1 - average
C              2 - percent
C     MODOPT - plot parameter modification flag:  0-NO, 1-YES
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I0, I1, SGRP, CNUM, CVAL(16), IRET, CMDID, ERR, FRQCRV,
     $          DURCRV
C
C     + + + EXTERNALS + + +
      EXTERNAL  Q1INIT, QSETCO, Q1EDIT, QGETCO, ZSTCMA, PRNTXT
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 0
      I1 = 1
C
C     allow 'Previous' command
      CMDID = 4
      CALL ZSTCMA (CMDID, I1)
C
 10   CONTINUE
        ERR = 0
 20     CONTINUE
          SGRP = 41
C         display graphical display options screen
          CALL Q1INIT (MESSFL, SCLU, SGRP)
C         supply defaults to screen
          CNUM = 16
          CVAL(1) = PLTDEV(1,1) + 1
          CVAL(2) = PLTDEV(2,1) + 1
          CVAL(3) = FRQOPT(1) + 1
          CVAL(4) = FRQOPT(2) + 1
          CVAL(5) = FRQOPT(3) + 1
          CVAL(6) = PLTDEV(1,2) + 1
          CVAL(7) = PLTDEV(2,2) + 1
          CVAL(8) = DUROPT(1) + 1
          CVAL(9) = DUROPT(2) + 1
          CVAL(10) = DUROPT(3) + 1
          CVAL(11) = PLTDEV(1,3) + 1
          CVAL(12) = PLTDEV(2,3) + 1
          CVAL(13) = SEAOPT
          CVAL(14) = HYDDEV(1) + 1
          CVAL(15) = HYDDEV(2) + 1
          CVAL(16) = MODOPT + 1
          CALL QSETCO (CNUM, CVAL)
C         allow user to edit screen
          CALL Q1EDIT (IRET)
C
C       if user chose 'Oops' redraw screen
        IF (IRET .EQ. -1) GOTO 20
C
        IF (IRET .EQ. 1) THEN
C         continue; get values from screen
          CALL QGETCO (CNUM,
     O                 CVAL)
          PLTDEV(1,1) = CVAL(1) - 1
          PLTDEV(2,1) = CVAL(2) - 1
          FRQOPT(1) = CVAL(3) - 1
          FRQOPT(2) = CVAL(4) - 1
          FRQOPT(3) = CVAL(5) - 1
          PLTDEV(1,2) = CVAL(6) - 1
          PLTDEV(2,2) = CVAL(7) - 1
          DUROPT(1) = CVAL(8) - 1
          DUROPT(2) = CVAL(9) - 1
          DUROPT(3) = CVAL(10) - 1
          PLTDEV(1,3) = CVAL(11) - 1
          PLTDEV(2,3) = CVAL(12) - 1
          SEAOPT = CVAL(13)
          HYDDEV(1) = CVAL(14) - 1
          HYDDEV(2) = CVAL(15) - 1
          MODOPT = CVAL(16) - 1
C
C         check if curves were chosen for freq. and flow dur. plots
          FRQCRV = FRQOPT(1) + FRQOPT(2) + FRQOPT(3)
          DURCRV = DUROPT(1) + DUROPT(2) + DUROPT(3)
C         if plots selected but no curves chosen, set error flag
          IF ((PLTDEV(1,1).NE.0 .OR. PLTDEV(2,1).NE.0) .AND.
     $        FRQCRV .EQ. 0) ERR = 1
          IF ((PLTDEV(1,2).NE.0 .OR. PLTDEV(2,2).NE.0) .AND.
     $        DURCRV .EQ. 0) ERR = 1
C
          IF (ERR .EQ. 1) THEN
C           turn off 'Previous'
            CALL ZSTCMA (CMDID, I0)
C
C           display error message
            SGRP = 42
            CALL PRNTXT (MESSFL, SCLU, SGRP)
C
C           allow 'Previous' command
            CALL ZSTCMA (CMDID, I1)
          END IF
C       end if (iret .eq. 1)
        END IF
      IF (ERR .EQ. 1) GOTO 10
C
C     turn off 'Previous'
      CALL ZSTCMA (CMDID, I0)
C
      RETURN
      END
C
C
C
      SUBROUTINE   BSMTHD
     I                   (MESSFL, SCLU,
     M                    METH)
C
C     + + + PURPOSE + + +
C     Select base flow separation method.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, SCLU, METH
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - screen cluster number on message file
C     METH   - base flow separation method
C              1 - fixed interval method
C              2 - sliding interval method
C              3 - local minimum method
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I0, I1, SGRP, LINE, DUM1, DUMLEN, DUM3, RESP, 
     $             CMDID, IRET
      CHARACTER*1  DUM2(1)
      CHARACTER*16 METHOD(3)
C
C     + + + EXTERNALS + + +
      EXTERNAL   BSSTAT
      EXTERNAL   QRESP, ZSTCMA, ZGTRET
C
C     + + + DATA INITIALIZATION + + +
      DATA  METHOD / 'Fixed interval  ',
     $               'Sliding interval',
     $               'Local minimum   ' /
C
C     + + + END SPECIFICATIONS + + +
C
      DUM1 = 0
      DUMLEN = 1
      DUM2(1) = ' '
      DUM3 = 0
C
C     allow 'Previous' command
      CMDID = 4
      I1 = 1
      CALL ZSTCMA (CMDID, I1)
C
C     select separation method (1-fixed intv,2-sliding intv,3-local min)
      SGRP = 51
      CALL QRESP (MESSFL, SCLU, SGRP, RESP)
C
C     get screen exit status code
      CALL ZGTRET (IRET)
C
      IF (IRET .NE. 2) THEN
        METH = RESP
C       update status line
        LINE = 3
        CALL BSSTAT (LINE, DUM1, DUMLEN, DUM2, DUM3, METHOD(METH))
      END IF
C
C     turn off 'Previous'
      I0 = 0
      CALL ZSTCMA (CMDID, I0)
C
      RETURN
      END
C
C
C
      SUBROUTINE   BSSTAT
     I                   (STLINE, WDMSFL, BASLEN, BASNAM, DSNCNT, 
     I                    METHOD)
C
C     + + + PURPOSE + + +
C     Updates the status window.  Status information includes the name 
C     of the input file, the number of stations to be processed, the 
C     name of the output file, and the separation method being used.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   STLINE, WDMSFL, BASLEN, DSNCNT
      CHARACTER*1  BASNAM(BASLEN)
      CHARACTER*16 METHOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STLINE - status line to update
C              > 0 - update that line
C                1 - input file name
C                2 - number of stations to process
C                3 - separation method
C                4 - base name for output files
C              = 0 - initialize status to defaults
C              < 0 - update all lines
C     WDMSFL - Fortran unit number of WDM file
C     BASLEN - allowable length for base name
C     BASNAM - base name for output files
C     DSNCNT - number of data sets in the buffer
C     METHOD - hydrograph separation method
C
C     + + + SAVES + + +
      CHARACTER*78 TXT(4)
      SAVE         TXT
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I0, LINE1, LINE2, LINE3, LINE4, LINEMX,
     $             JUSTL, LEN, LENF, LEN3, LEN64, L
      CHARACTER*1  COUNT(3), FNAME(64)
C
C     + + + FUNCTIONS + + +
      INTEGER   LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   LENSTR, CARVAR, INTCHR
      EXTERNAL   QFSTAT
      EXTERNAL   ZSTADQ
C
C     + + + DATA INITIALIZATION + + +
      DATA LINE1, LINE2, LINE3, LINE4, LINEMX, JUSTL
     $    /    1,     2,     3,     4,      4,    0 /
      DATA LENF, LEN3, LEN64
     $    /  64,    3,    64 /
      DATA TXT / 'Input file:  not specified',
     $           'Number of stations to be processed:  0',
     $           'Base-flow separation method:  ',
     $           'Output base name:  hysep'/
C
C     + + + END SPECIFICATIONS + + +
C
      IF (STLINE .EQ. 0) THEN
C       initialize system status
        TXT(3)(31:46) = METHOD
        DO 100 L = 1, LINEMX
          CALL ZSTADQ (L, TXT(L), I0)
 100    CONTINUE
      ELSE
C       update system status
        IF (STLINE .EQ. 1  .OR.  STLINE .LT. 0) THEN
          IF (WDMSFL .NE. 0) THEN
C           update source file name
            CALL QFSTAT (WDMSFL, FNAME)
            LEN = LENSTR (LENF, FNAME)
            CALL CARVAR (LEN, FNAME, LEN64, TXT(1)(14:77))
          ELSE
            TXT(1) = 'Input file:  not specified'
          END IF
          CALL ZSTADQ (LINE1, TXT(1), I0)
        END IF
        IF (STLINE .EQ. 2  .OR.  STLINE .LT. 0) THEN
C         update number of data sets
          IF (DSNCNT .LE. 0) THEN
C           no data sets in buffer
            TXT(2)(38:40) = '0  '
          ELSE
C           data sets in buffer
            CALL INTCHR (DSNCNT, LEN3, JUSTL, LEN, COUNT)
            CALL CARVAR (LEN, COUNT, LEN3, TXT(2)(38:40))
          END IF
          CALL ZSTADQ (LINE2, TXT(2), I0)
        END IF
        IF (STLINE .EQ. 3  .OR.  STLINE .LT. 0) THEN
C         update separation method
          TXT(3)(31:46) = METHOD
          CALL ZSTADQ (LINE3, TXT(3), I0)
        END IF
        IF (STLINE .EQ. 4  .OR.  STLINE .LT. 0) THEN
C         update base name for output files
          CALL CARVAR (BASLEN, BASNAM, BASLEN, TXT(4)(20:76))
          CALL ZSTADQ (LINE4, TXT(4), I0)
        END IF
      END IF
C
      RETURN
      END
